package com.composition.android.ad.gromore.load.request

import android.app.Activity
import android.content.Context
import com.bytedance.msdk.api.AdError
import com.bytedance.msdk.api.v2.GMAdConstant
import com.bytedance.msdk.api.v2.ad.reward.GMRewardAd
import com.bytedance.msdk.api.v2.ad.reward.GMRewardedAdLoadCallback
import com.bytedance.msdk.api.v2.slot.GMAdSlotRewardVideo
import com.composition.android.ad.gromore.load.util.GMSettingConfig
import com.composition.android.ad.gromore.load.util.printAdFailInfo
import com.composition.android.lib.ad.basic.AdResult
import com.composition.android.lib.ad.bean.AdUnitBean
import com.composition.android.lib.ad.interfaces.IAdFormatRequest
import kotlinx.coroutines.suspendCancellableCoroutine
import kotlin.coroutines.resume

/**
 * @classname:
 * @author: LiuXiaoLong
 * @date: 2022/9/16
 * description: GroMore 激励视频广告加载类
 */
class GMRewardRequestImpl : IAdFormatRequest {
    override suspend fun load(context: Context, adUnitBean: AdUnitBean): AdResult {

        return suspendCancellableCoroutine {
            if (context is Activity){
                GMSettingConfig.loadAdConfig {
                    val gmRewardAd = GMRewardAd(context, adUnitBean.adUnitId)
                    gmRewardAd.loadAd(GMAdSlotRewardVideo.Builder()
                        .setRewardAmount(1)
                        .setMuted(true)
                        .setOrientation(GMAdConstant.VERTICAL)
                        .build(), object : GMRewardedAdLoadCallback{
                        override fun onRewardVideoLoadFail(p0: AdError) {
                           printAdFailInfo(p0.code, p0.message)
                            if (it.isActive){
                                it.resume(AdResult.Fail(adUnitBean, msg = "GroMore激励视频广告加载失败:${p0.message}"))
                            }
                        }

                        override fun onRewardVideoAdLoad() {
                        }

                        override fun onRewardVideoCached() {
                            if (it.isActive){
                                it.resume(AdResult.Success(adBean = adUnitBean, adObject = gmRewardAd, msg = "GroMore激励视频广告加载成功"))
                            }
                        }

                    })
                }
            }else{
                printAdFailInfo(0, "GroMore加载激励视频广告需要context为Activity")
                if (it.isActive){
                    it.resume(AdResult.Fail(adUnitBean, msg = "GroMore加载激励视频广告需要context为Activity"))
                }
            }

        }
    }
}